<?php
/**
 * NesCat (Nesquik catalog) 0.1 stable
 *
 * Система представляет собой скрипт для каталога сайтов
 * Система написана на PHP, хранящая данные в БД MYSQL
 * Высокая скорость работы скрипта, устойчивость к нагрузкам
 *
 * Автор: Провокатор
 * ICQ: 551-228
 *
 * Вы не имеете право продавать скрипта
 * Вы не имеете право вылаживать скрипта
 * Все права на данный скрипт пренадлежат его автору
 *
 * Все права защищены © 2010
 */

/* Запускаем сессии */
session_start();

/* Уровень вывода ошибок */
error_reporting(E_ALL & ~E_NOTICE);

/* Подключаем файл с фукнциями */
if (file_exists(dirname(__FILE__).'/function.php')) {
	require_once (dirname(__FILE__).'/function.php');
} else {
	exit ('Немогу подключить файл с настройками!');
}

/* Подключаем файл с настройками */
if (file_exists(dirname(__FILE__).'/config.php')) {
	require_once (dirname(__FILE__).'/config.php');
} else {
	exit ('Немогу подключить файл с настройками!');
}

/* Подключаем файл для работы с базой данных */
if (file_exists(dirname(__FILE__).'/mysql.class.php')) {
	require_once (dirname(__FILE__).'/mysql.class.php');
} else {
	exit ('Немогу подключить файл для работы с базой данный!');
}

/* Подключаемся к базе данных */
$db = new MYSQL(DATAHOST, DATAUSER, DATAPASS, DATABASE, DATABASE_CHARSET);

/* Задаем кодировку по умолчанию для iconv */
iconv_set_encoding('internal_encoding', 'UTF-8');

/* Проверяем и фильтруем переменные */
$id = isset($_GET['id']) ? abs(intval($_GET['id'])) : 0;
$act = isset($_GET['act']) ? urldecode($_GET['act']) : false;

/* Задаем имена таблицам */
define('CATEGORY', prefix.'category');
define('SITE', prefix.'site');
define('USERS', prefix.'users');
define('SETTINGS', prefix.'settings');
define('OPERATOR', prefix.'oper');
define('IP', prefix.'ip');
define('LOGS', prefix.'logs');
define('ONLINE', prefix.'online');
define('COMMENT', prefix.'comment');
define('NEWS', prefix.'news');
define('FORGOT', prefix.'forgot');
define('SETTINGS', prefix.'settings');
define('REKL', prefix.'rekl');
define('REKLOGS', prefix.'reklogs');
define('TICKET', prefix.'ticket');
define('TICKETMSG', prefix.'ticketmsg');
define('ONLINECAT', prefix.'onlinecat');

/* Аутенфикация пользователя */
if (isset($_SESSION['login'], $_SESSION['password'])) {
	$user = authentication ($_SESSION['login'], $_SESSION['password']);
} else {
	$user = false;
}

/* Настройки скрипта */
$sql = $db->query("SELECT * FROM `".SETTINGS."` WHERE `id`='1'");

if ($db->num_rows($sql)) {
	$set = $db->fetch_assoc($sql);
} else {
	error ('Не установлены настройки скрипта!', PATH, 'На главную');
}

/* Удаление запросов на изменение пароля */
$db->query("DELETE FROM `".FORGOT."` WHERE `date`<=(CURDATE() - INTERVAL 1 DAY) LIMIT 50");

/* Удаление рекламных ссылок */
$db->query("DELETE FROM `".REKL."` WHERE `date`<='".time()."'");

/* Удаляем старых гостей из онлайн */
$db->query("DELETE FROM `".ONLINECAT."` WHERE `date`<=(NOW() - INTERVAL 3 MINUTE) LIMIT 30");

/* Обновленик каталога (CRON) */
if (date('d') != $set['cron_time']) {
	$db->query("UPDATE `".SITE."` SET `in`='0', `out`='0'");
	$db->query("TRUNCATE TABLE `".REKLOGS."`");
	$db->query("UPDATE `".SETTINGS."` SET `cron_time`='".date('d')."'");
}
?>