<?php
/**
 * NesCat (Nesquik catalog) 0.1 stable
 *
 * Система представляет собой скрипт для каталога сайтов
 * Система написана на PHP, хранящая данные в БД MYSQL
 * Высокая скорость работы скрипта, устойчивость к нагрузкам
 *
 * Автор: Провокатор
 * ICQ: 551-228
 *
 * Вы не имеете право продавать скрипта
 * Вы не имеете право вылаживать скрипта
 * Все права на данный скрипт пренадлежат его автору
 *
 * Все права защищены © 2010
 */

/* Подключаем системный файл */
if (file_exists('../__incfiles/core.php')) {
	require_once ('../__incfiles/core.php');
} else {
	exit ('Немогу подключить системный файл!');
}

define('ROOT', PATH.'/admin');
define('NEWSFILE', ROOT.'/news.xhtml');

access ('news');

switch ($act) {

	default:

	$count_news = $db->result("SELECT COUNT(`id`) FROM `".NEWS."` WHERE `ref`=''", 1);

	require_header ('Управление новостями');
	echo '<div class="main"><b>Всего новостей: '.$count_news.'</b></div>';

	$k_page = k_page($count_news, $set['news']); 
	$page = page($k_page);

	$sql = $db->query("SELECT `id`, `name`, `text`, `date`, `comment` FROM `".NEWS."` WHERE `ref`='' ORDER BY `id` DESC LIMIT ".($set['news'] * $page - $set['news']).", ".$set['news']);

	if ($db->num_rows($sql) == 0) {
		echo '<div class="error">Новостей еще нет!</div>';
	} else {

		while ($row = $db->fetch_assoc($sql)) {
			echo '<div class="alt"><b>'.htmlspecialchars($row['name']).'</b> ['.clock($row['date']).']</div>
			<div class="line">'.nl2br(bbcode(smiles(htmlspecialchars($row['text'])))).'<br/>';
			
			if ($row['comment']) {
				echo '<a href="'.NEWSFILE.'/comment/'.$row['id'].'/">Комментарии</a> ['.$db->result("SELECT COUNT(`id`) FROM `".NEWS."` WHERE `ref`='".$row['id']."'", 1).']<br/>';
			}
			
			echo '<small><a href="'.NEWSFILE.'/edit/'.$row['id'].'/">Изменить</a> / <a href="'.NEWSFILE.'/delete/'.$row['id'].'/">Удалить</a></small></div>';
		}
		
		if ($k_page > 1) {
			navigation(NEWSFILE.'/', $k_page, $page);
		}
	}

	echo '<div class="title">Добавить новость</div>';

	if (isset($_POST['submit'])) {
		
		$error = '';
		
		if (empty($_POST['name'])) {
			$error .= 'Введите название новости!<br/>';
		}
		elseif (iconv_strlen($_POST['name']) < 5 || iconv_strlen($_POST['name']) > 50) {
			$error .= 'Название должно содержать от 5 до 50 символов!<br/>';
		}
		elseif ($db->num_rows("SELECT (`id`) FROM `".NEWS."` WHERE `ref`='' AND `name`='".$db->escape($_POST['name'])."' LIMIT 1", 1)) {
			$error .= 'Новость с таким названием уже существует!<br/>';
		}
		
		if (empty($_POST['text'])) {
			$error .= 'Введите текст новости!';
		}
		elseif (iconv_strlen($_POST['text']) < 10) {
			$error .= 'Слишком короткая новость!';
		}
		elseif ($db->num_rows("SELECT (`id`) FROM `".NEWS."` WHERE `ref`='' AND `text`='".$db->escape($_POST['text'])."' LIMIT 1", 1)) {
			$error .= 'Такая новость уже существует!<br/>';
		}
		
		if ($error) {
			echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
		} else {
		
			if ($db->query("INSERT INTO `".NEWS."` SET `ref`='', `date`='".time()."', `name`='".$db->escape($_POST['name'])."', `text`='".$db->escape($_POST['text'])."', `comment`='".intval($_POST['comment'])."'")) {
				echo '<div class="line"><b>Новость "'.htmlspecialchars($_POST['name']).'" успешно добавлена!</b></div>';
				header ('Refresh: 1');
			} else {
				echo '<div class="error">Ошибка при добавлении новости!<br/><b>'.$db->SQLerror().'</b></div>';
			}
		
		}

	}

	echo '<form class="menu" action="" method="post">
	<b>Название</b>:<br/><input type="text" name="name" maxlength="50"/><br/>
	<b>Новость</b>:<br/><textarea name="text" rows="3" cols="30"></textarea><br/>
	<input type="checkbox" name="comment" value="1" checked="checked"/> Включить комментарии<br/>
	<input type="submit" name="submit" value="Добавить"/>
	</form>';

	require_footer (ROOT.'/index.xhtml', 'Админ-панель');

	break;
	
	case 'comment_delete':
	
	$sql = $db->query("SELECT (`ref`) FROM `".NEWS."` WHERE `ref`<>'' AND `id`='".$id."'");
	
	if ($db->num_rows($sql)) {
		$row = $db->fetch_assoc($sql);
	} else {
		error ('Комментарий не найден!', NEWSFILE, 'Все новости');
	}
	
	require_header ('Удалить новость, ID: '.$id);
	
	if (isset($_POST['delete'])) {
		if ($db->query("DELETE FROM `".NEWS."` WHERE `id`='".$id."'")) {
			echo '<div class="line"><b>Комментарий успешно удален!</b></div>';
			header ('Refresh: 1, url='.NEWSFILE);
		} else {
			echo '<div class="error">Ошибка при удалении комментария!<br/><b>'.$db->SQLerror().'</b></div>';
		}
	}
	
	echo '<form class="menu" action="" method="post">
	<b>Вы действительно хотите удалить данный комментарий?</b><br/>
	<input type="submit" name="delete" value="Да"/> <a href="'.NEWSFILE.'/comment/'.$row['ref'].'/"><input type="button" value="Нет"/></a>
	</form>';
	
	require_footer (NEWSFILE.'/comment/'.$row['ref'].'/', 'К комментариям');
	
	break;
	
	case 'comment':
	
	$sql = $db->query("SELECT (`comment`) FROM `".NEWS."` WHERE `ref`='' AND `id`='".$id."'");
	
	if ($db->num_rows($sql)) {
		$news = $db->fetch_assoc($sql);
	} else {
		error ('Новость не найдена!', NEWSFILE, 'Все новости');
	}
	
	unset($sql);
	
	if ($news['comment'] == 0) {
		error ('Комментарии к данной новости отключены!', NEWSFILE, 'Все новости');
	}
	
	$sql = $db->query("SELECT * FROM `".NEWS."` WHERE `ref`='".$id."'");
	
	$count_comment = $db->result("SELECT COUNT(`id`) FROM `".NEWS."` WHERE `ref`='".$id."'", 1);

	require_header ('Комментарии к новости, ID: '.$id);
	echo '<div class="main"><b>Всего комментариев: '.$count_comment.'</b></div>';

	$k_page = k_page($count_comment, $set['comment']); 
	$page = page($k_page);
	
	$sql = $db->query("SELECT * FROM `".NEWS."` WHERE `ref`='".$id."' ORDER BY `id` DESC LIMIT ".($set['comment'] * $page - $set['comment']).", ".$set['comment']);

	if ($db->num_rows($sql) == 0) {
		echo '<div class="error">Комментариев нет!</div>';
	} else {
		
		while ($row = $db->fetch_assoc($sql)) {
			echo '<div class="alt"><b>'.htmlspecialchars($row['name']).'</b> ['.clock($row['date']).']</div>
			<div class="line">'.nl2br(bbcode(smiles(htmlspecialchars($row['text'])))).'<br/>';
			if (!empty($row['answer'])) {
				echo '<span style="color:red"><b>Ответ:</b> '.nl2br(bbcode(smiles(htmlspecialchars($row['answer'])))).'</span><br/>';
			}
			echo '<small><a href="'.NEWSFILE.'/comment_edit/'.$row['id'].'/">Изменить</a> / <a href="'.NEWSFILE.'/comment_delete/'.$row['id'].'/">Удалить</a></small></div></div>';
		}
		
		if ($k_page > 1) {
			navigation(PATH.'/news/comment.xhtml/', $k_page, $page);
		}
		
	}
	
	echo '<div class="title">Добавить комментарий</div>';
	
	if (isset($_POST['text'])) {
		
		$error = '';
		
		if (isset($_SESSION['comment_news']) && $_SESSION['comment_news'] > (time() - 5)) {
			$error .= 'Следующий комментарий можно будет добавить через '.($_SESSION['comment_news'] - (time() - 5)).'сек!<br/>';
		}
		
		if (empty($_POST['text'])) {
			$error .= 'Комментарий не должен быть пустым!';
		}
		elseif (iconv_strlen($_POST['text']) < 10) {
			$error .= 'Слишком короткий комментарий!';
		}
		
		if ($error) {
			echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
		} else {
		
			if ($db->query("INSERT INTO `".NEWS."` SET `date`='".time()."', `ref`='".$id."', `name`='".$db->escape($user['login'])."', `text`='".$db->escape($_POST['text'])."'")) {
				$_SESSION['comment_news'] = time();
				echo '<div class="line"><b>Комментарий успешно добавлен!</div>';
				header ('Refresh: 1, url='.NEWSFILE.'/comment/'.$id.'/');
			} else {
				echo '<div class="error">Ошибка при добавлении комментария!<br/><b>'.$db->SQLerror().'</b></div>';
			}
		
		}
	
	}
	
	echo '<form name="form" class="menu" action="" method="post">
	<b>Комментарий</b>: [<small><a href="'.PATH.'/catalog.xhtml/smiles/">Смайлы</a> / <a href="'.PATH.'/catalog.xhtml/bbcode/">ББ-коды</a></small>]<br/><textarea name="text" rows="3" cols="30"></textarea><br/>
	<input type="submit" name="submit" value="Добавить"/>
	</form>';
	
	require_footer (NEWSFILE, 'Все новости');
	
	break;
	
	case 'comment_edit':
	
	$sql = $db->query("SELECT `ref`, `name`, `text`, `answer` FROM `".NEWS."` WHERE `ref`<>'' AND `id`='".$id."'");
	
	if ($db->num_rows($sql)) {
		$comment = $db->fetch_assoc($sql);
	} else {
		error ('Такого комментария не существует!', NEWSFILE, 'Все новости');
	}
	
	require_header ('Изменить комментарий, ID: '.$id);
	
	if (isset($_POST['text'])) {
		
		$error = '';

		if (empty($_POST['login'])) {
			$error .= 'Введите логин запостившего!<br/>';
		}
		elseif (!preg_match('/(^[a-zA-Z0-9\-_]{3,13}+)$/', $_POST['login'])) {
			$error .= 'Логин должен быть формата _a-Z0-9- не менее 3 и не более 13 символов!<br/>';
		}
		
		if (empty($_POST['text'])) {
			$error .= 'Комментарий не должен быть пустым!';
		}
		elseif (iconv_strlen($_POST['text']) < 10) {
			$error .= 'Слишком короткий комментарий!';
		}
		
		if ($error) {
			echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
		} else {
		
			if ($db->query("UPDATE `".NEWS."` SET `name`='".$db->escape($_POST['login'])."', `text`='".$db->escape($_POST['text'])."', `answer`='".$db->escape($_POST['answer'])."' WHERE `id`='".$id."'")) {
				$_SESSION['comment_news'] = time();
				echo '<div class="line"><b>Комментарий успешно изменен!</div>';
				header ('Refresh: 1, url='.NEWSFILE.'/comment/'.$comment['ref'].'/');
			} else {
				echo '<div class="error">Ошибка при изменении комментария!<br/><b>'.$db->SQLerror().'</b></div>';
			}
		
		}
	
	}
	
	echo '<form name="form" class="menu" action="" method="post">
	<b>Логин</b>:<br/><input type="text" name="login" value="'.htmlspecialchars($comment['name']).'" maxlength="13"/><br/>
	<b>Комментарий</b>: [<small><a href="'.PATH.'/catalog.xhtml/smiles/">Смайлы</a> / <a href="'.PATH.'/catalog.xhtml/bbcode/">ББ-коды</a></small>]<br/><textarea name="text" rows="3" cols="30">'.htmlspecialchars($comment['text']).'</textarea><br/>
	<b>Ответи администратора</b>:<br/><textarea name="answer" rows="2" cols="30">'.htmlspecialchars($comment['answer']).'</textarea><br/>
	<input type="submit" name="submit" value="Изменить"/>
	</form>';
	
	require_footer (NEWSFILE.'/comment/'.$comment['ref'].'/', 'К комментариям');
	
	break;
	
	case 'edit':
	
	$sql = $db->query("SELECT `name`, `text`, `comment` FROM `".NEWS."` WHERE `ref`='' AND `id`='".$id."'");
	
	if ($db->num_rows($sql)) {
		$row = $db->fetch_assoc($sql);
	} else {
		error ('Новость не найдена!', NEWSFILE, 'Все новости');
	}
	
	unset($sql);
	
	require_header ('Изменить новость, ID: '.$id);
	
	if (isset($_POST['submit'])) {
		
		$error = '';
		
		if (empty($_POST['name'])) {
			$error .= 'Введите название новости!<br/>';
		}
		elseif (iconv_strlen($_POST['name']) < 5 || iconv_strlen($_POST['name']) > 50) {
			$error .= 'Название должно содержать от 5 до 50 символов!<br/>';
		}
		elseif ($db->num_rows("SELECT (`id`) FROM `".NEWS."` WHERE `ref`='' AND `name`='".$db->escape($_POST['name'])."' AND `id`<>'".$id."' LIMIT 1", 1)) {
			$error .= 'Новость с таким названием уже существует!<br/>';
		}
		
		if (empty($_POST['text'])) {
			$error .= 'Введите текст новости!';
		}
		elseif (iconv_strlen($_POST['text']) < 10) {
			$error .= 'Слишком короткая новость!';
		}
		elseif ($db->num_rows("SELECT (`id`) FROM `".NEWS."` WHERE `ref`='' AND `text`='".$db->escape($_POST['text'])."' AND `id`<>'".$id."' LIMIT 1", 1)) {
			$error .= 'Такая новость уже существует!<br/>';
		}
		
		if ($error) {
			echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
		} else {
		
			if ($db->query("UPDATE `".NEWS."` SET `name`='".$db->escape($_POST['name'])."', `text`='".$db->escape($_POST['text'])."', `comment`='".intval($_POST['comment'])."' WHERE `id`='".$id."'")) {
				
				if (!empty($_POST['delete_comment'])) {
					$db->query("DELETE FROM `".NEWS."` WHERE `ref`='".$id."'");
				}
				
				echo '<div class="line"><b>Новость "'.htmlspecialchars($_POST['name']).'" успешно обновлена!</b></div>';
				header ('Refresh: 1, url='.NEWSFILE);
			} else {
				echo '<div class="error">Ошибка при обновлении новости!<br/><b>'.$db->SQLerror().'</b></div>';
			}
		
		}

	}
	
	echo '<form class="menu" action="" method="post">
	<b>Название</b>:<br/><input type="text" name="name" value="'.htmlspecialchars($row['name']).'" maxlength="50"/><br/>
	<b>Новость</b>: [<small><a href="'.PATH.'/catalog.xhtml/smiles/">Смайлы</a> / <a href="'.PATH.'/catalog.xhtml/bbcode/">ББ-коды</a></small>]<br/><textarea name="text" rows="3" cols="30">'.htmlspecialchars($row['text']).'</textarea><br/>
	<input type="checkbox" name="comment" value="1" '.check(1, $row['comment']).'/> Включить комментарии<br/>
	<input type="checkbox" name="delete_comment" value="1"/> Очистить комментарии<br/>
	<input type="submit" name="submit" value="Изменить"/>
	</form>';
	
	require_footer (NEWSFILE, 'Все новости');
	
	break;
	
	case 'delete':
	
	$sql = $db->query("SELECT (`id`) FROM `".NEWS."` WHERE `ref`='' AND `id`='".$id."'");
	
	if ($db->num_rows($sql)) {
		$row = $db->fetch_assoc($sql);
	} else {
		error ('Новость не найдена!', NEWSFILE, 'Все новости');
	}
	
	require_header ('Удалить новость, ID: '.$id);
	
	if (isset($_POST['delete'])) {
		if ($db->query("DELETE FROM `".NEWS."` WHERE `id`='".$id."'")) {
			echo '<div class="line"><b>Новость успешно удалена!</b></div>';
			header ('Refresh: 1, url='.NEWSFILE);
		} else {
			echo '<div class="error">Ошибка при удалении новости!<br/><b>'.$db->SQLerror().'</b></div>';
		}
	}
	
	echo '<form class="menu" action="" method="post">
	<b>Вы действительно хотите удалить данную новость?</b><br/>
	<input type="submit" name="delete" value="Да"/> <a href="'.NEWSFILE.'"><input type="button" value="Нет"/></a>
	</form>';
	
	require_footer (NEWSFILE, 'Все новости');
	
	break;

}
?>