<?php
/**
 * NesCat (Nesquik catalog) 0.1 stable
 *
 * Система представляет собой скрипт для каталога сайтов
 * Система написана на PHP, хранящая данные в БД MYSQL
 * Высокая скорость работы скрипта, устойчивость к нагрузкам
 *
 * Автор: Провокатор
 * ICQ: 551-228
 *
 * Вы не имеете право продавать скрипта
 * Вы не имеете право вылаживать скрипта
 * Все права на данный скрипт пренадлежат его автору
 *
 * Все права защищены © 2010
 */

/* Подключаем системный файл */
if (file_exists('__incfiles/core.php')) {
	require_once ('__incfiles/core.php');
} else {
	exit ('Немогу подключить системный файл!');
}

if ($user) {
	header ('Location: '.PATH.'/profile/index.xhtml');
}
elseif ($set['registartion'] == false) {
	error ('Регистрация закрыта администрацией!', PATH, 'На главную');
}

require_header ('Регистрация в каталоге');
echo '<div class="main"><b>Все поля обязательны для заполнения.</b></div>';

if (isset($_POST['submit'])) {

	$error = '';
	
	if (empty($_POST['login'])) {
		$error .= 'Введите логин для регистрации!<br/>';
	}
	elseif (!preg_match('/(^[a-zA-Z0-9\-_]{3,13}+)$/', $_POST['login'])) {
		$error .= 'Логин должен быть формата _a-Z0-9- не менее 3 и не более 13 символов!<br/>';
	}
	elseif ($db->num_rows("SELECT (`id`) FROM `".USERS."` WHERE `login`='".$db->escape($_POST['login'])."' LIMIT 1", 1)) {
		$error .= 'Пользователь с логином "'.htmlspecialchars($_POST['login']).'" уже зарегистрирован!<br/>';
	}
	
	if (empty($_POST['password'])) {
		$error .= 'Введите пароль для аккаунта!<br/>';
	}
	elseif (!preg_match('/(^[a-zA-Z0-9\-_]{3,13}+)$/', $_POST['password'])) {
		$error .= 'Пароль долен содержать символы _a-Z0-9- не менее 4 и не более 15 символов!<br/>';
	}
	
	if (empty($_POST['last_password'])) {
		$error .= 'Введите проверочный пароль!<br/>';
	}
	elseif ($_POST['last_password'] != $_POST['password']) {
		$error .= 'Проверочный пароль введен не верно!<br/>';
	}
	
	if (empty($_POST['email'])) {
		$error .= 'Введите ваш почтовый ящик!<br/>';
	}
	elseif (!preg_match('|^([a-z0-9_\.\-]{1,20})@([a-z0-9\.\-]{1,20})\.([a-z]{2,4})$|ius', $_POST['email'])) {
		$error .= 'E-mail должен быть вида login@example.com!<br/>';
	}
	elseif ($db->num_rows("SELECT (`id`) FROM `".USERS."` WHERE `email`='".$db->escape($_POST['email'])."' LIMIT 1", 1)) {
		$error .= 'Пользователь с почтовым адресом "'.htmlspecialchars($_POST['email']).'" уже зарегистрирован!<br/>';
	}
	
	if (empty($_POST['code'])) {
		$error .= 'Введите код с картинки!';
	}
	elseif ($_SESSION['code'] != $_POST['code']) {
		$error .= 'Код с картинки введен не верно!';
	}
	
	if ($error) {
		echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
	}
	else {
	
		if ($db->query("INSERT INTO `".USERS."` SET `date_reg`=NOW(), `login`='".$db->escape($_POST['login'])."', `password`='".$db->escape(md5($_POST['password']))."', `email`='".$db->escape($_POST['email'])."'")) {
		
			$mail = array (
			'email' => htmlspecialchars($_POST['email']),
			'theme' => 'Регистрация в каталоге',
			'message' => 'Доброе время суток!'."\n".'Вы зарегистрировались в каталоге, по адресу: '.PATH."\n".'Ваши данные для входа в личный кабинет:'."\n".'Логин: '.htmlspecialchars($_POST['login'])."\n".'Пароль: '.htmlspecialchars($_POST['password'])."\n".'Ссылка для автологина: '.PATH.'/auth.xhtml?login='.htmlspecialchars($_POST['login']).'&password='.htmlspecialchars($_POST['password'])."\n".'Удачной раскрутки, с ув. администрация '.getenv('HTTP_HOST')
			);
			
			mailto ($mail['email'], $mail['theme'], $mail['message']);
			
			if ($db->SQLID() == 1) {
				$db->query("UPDATE `".USERS."` SET `admin`='1' WHERE `id`='1'");
			}
			
			echo '<div class="alt"><b>Вы успешно зарегистрированы!</b></div>
			<div class="line">
			Ваши данные для входа в личный кабинет:<br/>
			<b>Логин:</b> '.htmlspecialchars($_POST['login']).'<br/>
			<b>Пароль:</b> '.htmlspecialchars($_POST['password']).'</div>
			<div class="str">Ссылка для автологина:<br/><input type="text" value="'.PATH.'/auth.xhtml?login='.htmlspecialchars($_POST['login']).'&amp;password='.htmlspecialchars($_POST['password']).'"/></div>
			<div class="main"><b>Удачной раскрутки, с уважением администрация '.getenv('HTTP_HOST').'!</b></div>';
			
			exit(require_footer(PATH, 'На главную'));
		
		} else {
			echo '<div class="error">Ошибка при регистрации!<br/><b>'.$db->SQLerror().'</b></div>';
		}
	
	}

}

echo '<form class="menu" action="" method="post">
<b>Логин</b> [min: 3, max: 13]:<br/><input type="text" name="login" maxlength="13"/><br/>
<b>Пароль</b> [min: 4, max: 15]:<br/><input type="password" name="password" maxlength="15"/><br/>
<b>Повторите пароль</b>:<br/><input type="password" name="last_password" maxlength="15"/><br/>
<b>E-mail</b>:<br/><input type="text" name="email" maxlength="44"/><br/>
<b>Код с картинки</b>:<br/><img id="captcha" style="border: 1px solid black;" src="'.PATH.'/'.mt_rand(1111,9999).'.code" alt=""/><br/>
<input type="text" name="code" maxlength="5" size="6"/> <a href="javascript:captcha_reload();"><small>Обновить</small></a><br/>
<input type="submit" name="submit" value="Регистрация"/>
</form>';

require_footer (PATH, 'На главную');
?>