<?php
/**
 * NesCat (Nesquik catalog) 0.1 stable
 *
 * Система представляет собой скрипт для каталога сайтов
 * Система написана на PHP, хранящая данные в БД MYSQL
 * Высокая скорость работы скрипта, устойчивость к нагрузкам
 *
 * Автор: Провокатор
 * ICQ: 551-228
 *
 * Вы не имеете право продавать скрипта
 * Вы не имеете право вылаживать скрипта
 * Все права на данный скрипт пренадлежат его автору
 *
 * Все права защищены © 2010
 */

/* Подключаем системный файл */
if (file_exists('__incfiles/core.php')) {
	require_once ('__incfiles/core.php');
} else {
	exit ('Немогу подключить системный файл!');
}

require_header ('Поиск по каталогу');

$true = false;

if (isset($_POST['search'])) {
	
	$error = '';
	
	if (empty($_POST['search'])) {
		$error .= 'Введите ключевое слово для поиска!<br/>';
	}
	elseif (iconv_strlen($_POST['search']) < 3 || iconv_strlen($_POST['search']) > 25) {
		$error .= 'Ключевое слово должно содержать от 3 до 25 символов!<br/>';
	}
	
	if (!in_array($_POST['type'], array('url', 'name', 'description'))) {
		$error .= 'Не верно выбрат тип поиска!';
	}
	
	if ($error) {
		echo '<div class="error"><b>Возникшие ошибки:</b><br/>'.$error.'</div>';
	} else {
		$true = true;
	}

}

echo '<form class="menu" action="" method="post">
<b>Ключевое слово</b>:<br/><input type="text" name="search" value="'.($true ? htmlspecialchars($_POST['search']) : '').'" maxlength="25"/><br/>
<b>Искать в</b>:<br/>
<input type="radio" name="type" value="url" '.($true ? check('url', $_POST['type']) : 'checked="checked"').'/> Поиск по URL<br/>
<input type="radio" name="type" value="name" '.($true ? check('name', $_POST['type']) : '').'/> Поиск по названию<br/>
<input type="radio" name="type" value="description" '.($true ? check('description', $_POST['type']) : '').'/> Поиск по описанию<br/>
<input type="submit" name="submit" value="Искать"/>
</form>';

if ($true) {
	
	echo '<div class="title">Результаты запроса</div>';
	
	$sql = $db->query("SELECT `s`.`id`, `s`.`stat`, `s`.`banner`, `s`.`name`, `s`.`description`, `s`.`comment`, `s`.`in`, `s`.`out`, COUNT(`o`.`id`) AS `online` FROM `".SITE."` AS `s` LEFT JOIN `".ONLINE."` AS `o` ON (`o`.`ref`=`s`.`id` AND `o`.`date`>=(NOW() - INTERVAL 3 MINUTE)) WHERE `".$db->escape($_POST['type'])."` LIKE '%".$db->escapeLike($_POST['search'])."%' AND `s`.`in`>='1' AND `s`.`status`='1' GROUP BY `s`.`id` ORDER BY `s`.`in` DESC");
	
	if ($db->num_rows($sql) == 0) {
		echo '<div class="error">По вашему запросу ничего не найдено!</div>';
	} else {
		while ($row = $db->fetch_assoc($sql)) {
			$rate = $db->fetch_row("SELECT SUM(`true`), (SELECT SUM(`false`) FROM `".COMMENT."` WHERE `ref`='".$row['id']."') FROM `".COMMENT."` WHERE `ref`='".$row['id']."'", 1);

			echo '<div class="alt"><a href="'.PATH.'/'.$row['id'].'.out"><b>'.htmlspecialchars($row['name']).'</b></a> '.($row['stat'] ? '<a href="'.PATH.'/info/'.$row['id'].'/"><img src="'.PATH.'/images/stat.gif" alt=""/></a>' : '').'</div>
			<div class="line"><small>'.htmlspecialchars($row['description']).'<br/>';
			if (!empty($row['banner']) && file_exists('images/banners/'.$row['banner'])) {
				echo '<img src="'.PATH.'/images/banners/'.htmlspecialchars($row['banner']).'" alt=""/><br/>';
			}
			if ($row['comment']) {
				echo '<a href="'.PATH.'/comment/'.$row['id'].'/">Отзывы</a> [<span style="color:green">'.intval($rate[0]).'</span>/<span style="color:red">'.intval($rate[1]).'</span>]<br/>';
			}
			echo 'В каталог: '.$row['in'].' | Из каталога: '.$row['out'].' | OnLine: '.$row['online'].'</small></div>';
		}
	}
	
}

require_footer (PATH, 'На главную');
?>